/* Unicode setting if needed
#ifndef UNICODE
#define UNICODE
#endif
*/

#pragma comment(lib, "netapi32.lib")

#include <stdio.h>
#include <windows.h> 
#include <lm.h>

int wmain(int argc, wchar_t *argv[])
{
   LPWKSTA_INFO_502 pBuf = NULL;
   WKSTA_INFO_502 wi;
   DWORD dwLevel = 502;
   NET_API_STATUS nStatus;
   LPWSTR pszServerName = NULL;

   if ((argc < 2) || (argc > 3))
   {
      fwprintf_s(stderr, L"Usage: %s [\\\\ServerName] SessionTimeOut\n", argv[0]);
	  wprintf(L"Example: %s \\\\MyBusinessServer 1000\n", argv[0]);
      exit(1);
   }

   if (argc == 3)
      pszServerName = argv[1];

   // Retrieve the current settings.
   nStatus = NetWkstaGetInfo(pszServerName,dwLevel,(LPBYTE *)&pBuf);

   if (nStatus != NERR_Success)
   {
	   wprintf(L"NetWkstaGetInfo() failed!\n");
	   fwprintf_s(stderr, L"A system error has occurred (NetWkstaGetInfo): %d\n", nStatus);
	   return -1;
   }
   else
	   wprintf(L"NetWkstaGetInfo() looks fine!\n");

   if (pBuf != NULL)
   {
      // Copy the existing settings to the new structure and free the buffer.
      CopyMemory(&wi, pBuf, sizeof(wi));
      NetApiBufferFree(pBuf);
   }
   else
   {
      fwprintf_s(stderr, L"Invalid memory lol!\n");
      return -1;
   }

   // Set a new session time-out value by
   //   calling the NetWkstaSetInfo function.
   wi.wki502_sess_timeout = _wtoi(argv[argc-1]);
   nStatus = NetWkstaSetInfo(pszServerName,dwLevel,(LPBYTE)&wi,NULL);

   // Display the result of the call.
   if (nStatus == NERR_Success)
   {
	   wprintf(L"NetWkstaSetInfo() is pretty fine!\n");
	   fwprintf_s(stderr, L"Workstation information reset: session time-out = %d\n", _wtoi(argv[argc-1]));
   }
   else
	   fwprintf_s(stderr, L"NetWkstaSetInfo() failed! A system error %d has occurred\n", nStatus);

   return 0;
}
